//
// Created by robin on 1/12/18.
//

#ifndef QDNSAGG_QDNSRECORDDATADECODER_H
#define QDNSAGG_QDNSRECORDDATADECODER_H

#include <QByteArray>

namespace QDns
{
    namespace Base
    {
        class QDnsRecordData
        {
        public:
            QDnsRecordData();

            virtual ~QDnsRecordData() = default;

            virtual QByteArray serialize() const = 0;

            virtual void serialize(QDataStream &dataStream) const = 0;

            bool isValid() const;

            virtual QDnsRecordData* clone() const = 0;

        protected:
            bool m_isValid;
        };
    }
}

#endif //QDNSAGG_QDNSRECORDDATADECODER_H
